---
title: Get all deployment gates
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Deployment Gates
---

# Get all deployment gates{% #get-all-deployment-gates %}
Copy pageCopied
{% tab title="v2" %}
**Note**: This endpoint is in preview and may be subject to change. If you have any feedback, contact [Datadog support](https://docs.datadoghq.com/help/).
| Datadog site      | API endpoint                                              |
| ----------------- | --------------------------------------------------------- |
| ap1.datadoghq.com | GET https://api.ap1.datadoghq.com/api/v2/deployment_gates |
| ap2.datadoghq.com | GET https://api.ap2.datadoghq.com/api/v2/deployment_gates |
| app.datadoghq.eu  | GET https://api.datadoghq.eu/api/v2/deployment_gates      |
| app.ddog-gov.com  | GET https://api.ddog-gov.com/api/v2/deployment_gates      |
| us2.ddog-gov.com  | GET https://api.us2.ddog-gov.com/api/v2/deployment_gates  |
| app.datadoghq.com | GET https://api.datadoghq.com/api/v2/deployment_gates     |
| us3.datadoghq.com | GET https://api.us3.datadoghq.com/api/v2/deployment_gates |
| us5.datadoghq.com | GET https://api.us5.datadoghq.com/api/v2/deployment_gates |

### Overview

Returns a paginated list of all deployment gates for the organization. Use `page[cursor]` and `page[size]` query parameters to paginate through results. This endpoint requires the `deployment_gates_read` permission.

### Arguments

#### Query Strings

| Name         | Type    | Description                                                                              |
| ------------ | ------- | ---------------------------------------------------------------------------------------- |
| page[cursor] | string  | Cursor for pagination. Use the `meta.page.next_cursor` value from the previous response. |
| page[size]   | integer | Number of results per page. Defaults to 50. Must be between 1 and 1000.                  |

### Response

{% tab title="200" %}
OK
{% tab title="Model" %}
Response containing a paginated list of deployment gates.

| Parent field | Field                        | Type      | Description                                                                            |
| ------------ | ---------------------------- | --------- | -------------------------------------------------------------------------------------- |
|              | data                         | [object]  | Array of deployment gates.                                                             |
| data         | attributes [*required*] | object    | Basic information about a deployment gate.                                             |
| attributes   | created_at [*required*] | date-time | The timestamp when the deployment gate was created.                                    |
| attributes   | created_by [*required*] | object    | Information about the user who created the deployment gate.                            |
| created_by   | handle                       | string    | The handle of the user who created the deployment rule.                                |
| created_by   | id [*required*]         | string    | The ID of the user who created the deployment rule.                                    |
| created_by   | name                         | string    | The name of the user who created the deployment rule.                                  |
| attributes   | dry_run [*required*]    | boolean   | Whether this gate is run in dry-run mode.                                              |
| attributes   | env [*required*]        | string    | The environment of the deployment gate.                                                |
| attributes   | identifier [*required*] | string    | The identifier of the deployment gate.                                                 |
| attributes   | service [*required*]    | string    | The service of the deployment gate.                                                    |
| attributes   | updated_at                   | date-time | The timestamp when the deployment gate was last updated.                               |
| attributes   | updated_by                   | object    | Information about the user who updated the deployment gate.                            |
| updated_by   | handle                       | string    | The handle of the user who updated the deployment rule.                                |
| updated_by   | id [*required*]         | string    | The ID of the user who updated the deployment rule.                                    |
| updated_by   | name                         | string    | The name of the user who updated the deployment rule.                                  |
| data         | id [*required*]         | string    | Unique identifier of the deployment gate.                                              |
| data         | type [*required*]       | enum      | Deployment gate resource type. Allowed enum values: `deployment_gate`                  |
|              | meta                         | object    | Metadata for a list of deployment gates response.                                      |
| meta         | page                         | object    | Pagination information for a list of deployment gates.                                 |
| page         | cursor                       | string    | The cursor used for the current page.                                                  |
| page         | next_cursor                  | string    | The cursor to use to fetch the next page. This is absent when there are no more pages. |
| page         | size                         | int64     | The number of results per page.                                                        |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": [
    {
      "attributes": {
        "created_at": "2021-01-01T00:00:00Z",
        "created_by": {
          "handle": "test-user",
          "id": "1111-2222-3333-4444-555566667777",
          "name": "Test User"
        },
        "dry_run": false,
        "env": "production",
        "identifier": "pre",
        "service": "my-service",
        "updated_at": "2021-01-01T00:00:00Z",
        "updated_by": {
          "handle": "test-user",
          "id": "1111-2222-3333-4444-555566667777",
          "name": "Test User"
        }
      },
      "id": "1111-2222-3333-4444-555566667777",
      "type": "deployment_gate"
    }
  ],
  "meta": {
    "page": {
      "cursor": "string",
      "next_cursor": "string",
      "size": "integer"
    }
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad request.
{% tab title="Model" %}
Bad request.

| Parent field | Field  | Type     | Description        |
| ------------ | ------ | -------- | ------------------ |
|              | errors | [object] | Structured errors. |
| errors       | detail | string   | Error message.     |
| errors       | status | string   | Error code.        |
| errors       | title  | string   | Error title.       |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Malformed payload",
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="401" %}
Unauthorized
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Forbidden
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="500" %}
Internal Server Error
{% tab title="Model" %}
Errors occurred.

| Parent field | Field  | Type     | Description        |
| ------------ | ------ | -------- | ------------------ |
|              | errors | [object] | Structured errors. |
| errors       | detail | string   | Error message.     |
| errors       | status | string   | Error code.        |
| errors       | title  | string   | Error title.       |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Malformed payload",
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \# Curl command curl -X GET "https://api.datadoghq.com/api/v2/deployment_gates" \
-H "Accept: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" 
                
##### 

```python
"""
Get all deployment gates returns "OK" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.deployment_gates_api import DeploymentGatesApi

configuration = Configuration()
configuration.unstable_operations["list_deployment_gates"] = True
with ApiClient(configuration) as api_client:
    api_instance = DeploymentGatesApi(api_client)
    response = api_instance.list_deployment_gates()

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# Get all deployment gates returns "OK" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.unstable_operations["v2.list_deployment_gates".to_sym] = true
end
api_instance = DatadogAPIClient::V2::DeploymentGatesAPI.new
p api_instance.list_deployment_gates()
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```go
// Get all deployment gates returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.ListDeploymentGates", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewDeploymentGatesApi(apiClient)
	resp, r, err := api.ListDeploymentGates(ctx, *datadogV2.NewListDeploymentGatesOptionalParameters())

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `DeploymentGatesApi.ListDeploymentGates`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `DeploymentGatesApi.ListDeploymentGates`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// Get all deployment gates returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.DeploymentGatesApi;
import com.datadog.api.client.v2.model.DeploymentGatesListResponse;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setUnstableOperationEnabled("v2.listDeploymentGates", true);
    DeploymentGatesApi apiInstance = new DeploymentGatesApi(defaultClient);

    try {
      DeploymentGatesListResponse result = apiInstance.listDeploymentGates();
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DeploymentGatesApi#listDeploymentGates");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```rust
// Get all deployment gates returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_deployment_gates::DeploymentGatesAPI;
use datadog_api_client::datadogV2::api_deployment_gates::ListDeploymentGatesOptionalParams;

#[tokio::main]
async fn main() {
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.ListDeploymentGates", true);
    let api = DeploymentGatesAPI::with_config(configuration);
    let resp = api
        .list_deployment_gates(ListDeploymentGatesOptionalParams::default())
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * Get all deployment gates returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
configuration.unstableOperations["v2.listDeploymentGates"] = true;
const apiInstance = new v2.DeploymentGatesApi(configuration);

apiInstance
  .listDeploymentGates()
  .then((data: v2.DeploymentGatesListResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
